#include "guipar.h"

GUIPar::GUIPar(QWidget *parent)
	: QWidget(parent)
{
	setupUi(this);
	
	par = new parser();
	
	double max = pow(double(10),double(308));
	edit->setMaxLength(max);
	resultEdit->setMaxLength(max);
	
	text->zoomIn(1.5);
	
	funcLayout = new QGridLayout(for_func);

	int colums = 9;
	int col = 0, str = 0;
    for (int i = 0; i < sizeof(func)/4; ++i)
	{
		funcLayout->addWidget(createButton(QString(QString(func[i])+"()")), str, col);
        
		if(col == colums) {col = 0; str++;}
		else col++;
	}
	verticalLayout->addLayout(funcLayout);
	 
	setChecked_for_checkBoxs();
	
	current = 0;
	item = true;

	connect(edit, SIGNAL(returnPressed ()), this, SLOT(Qtext()));
	connect(edit, SIGNAL(textEdited (const QString&)), this, SLOT(Qcurrent_text()));
	connect(edit, SIGNAL(textChanged(const QString&)), this, SLOT(forMaxLendthLineEdit()));
	
	connect(clearLineEdit, SIGNAL(clicked ()), this, SLOT(clearQLineEdit()));
	connect(clearLineEdit, SIGNAL(clicked ()), this, SLOT(removeFocus()));

	connect(enterHistory, SIGNAL( itemClicked( QListWidgetItem *)), this, SLOT(getCurrentIndexList(QListWidgetItem *)));
	connect(clearTextHistory, SIGNAL(clicked ()), this, SLOT(clearQListWidget()));
	connect(clearTextHistory, SIGNAL(clicked ()), this, SLOT(removeFocus()));
	
	connect(clearText, SIGNAL(clicked ()), this, SLOT(clearQTextEdit()));
	connect(clearText, SIGNAL(clicked ()), this, SLOT(removeFocus()));

	connect(on_rad, SIGNAL(clicked ()), this, SLOT(Check_on_rad()));
	connect(on_rad, SIGNAL(clicked ()), this, SLOT(removeFocus()));

	connect(operationInLog, SIGNAL(clicked ()), this, SLOT(Check_operationInLog()));
	connect(operationInLog, SIGNAL(clicked ()), this, SLOT(removeFocus()));

	connect(formulaInLog, SIGNAL(clicked ()), this, SLOT(Check_formulaInLog()));
	connect(formulaInLog, SIGNAL(clicked ()), this, SLOT(removeFocus()));

	connect(resultInLog, SIGNAL(clicked ()), this, SLOT(Check_resultInLog()));
	connect(resultInLog, SIGNAL(clicked ()), this, SLOT(removeFocus()));
}

QPushButton* GUIPar::createButton(const QString& str)
{
    QPushButton* pcmd = new QPushButton(str);
    pcmd->setMinimumSize(40, 25);
    connect(pcmd, SIGNAL(clicked()), this, SLOT(getCurrentButtonForFunc()));
	
	if(str == "sqrt()")
		pcmd->setToolTip(tr("Square root"));
	else if(str == "pi()")
		pcmd->setToolTip(tr("pi(x) - 3.14..*x"));
	else if(str == "deg()")
		pcmd->setToolTip(tr("Convert to degree"));
	else if(str == "rad()")
		pcmd->setToolTip(tr("Convert to radian"));
	else if(str == "log()")
		pcmd->setToolTip(tr("Natural logarithm"));
	else if(str == "log2()")
		pcmd->setToolTip(tr("Logarithm to base 2"));
	else if(str == "log10()")
		pcmd->setToolTip(tr("Logarithm to base 10"));
	else if(str == "int()")
		pcmd->setToolTip(tr("Integer of number"));
	else if(str == "frac()")
		pcmd->setToolTip(tr("Fraction of number"));
	else if(str == "exp()")
		pcmd->setToolTip(tr("e^x"));
	else if(str == "tan()")
		pcmd->setToolTip(tr("Tangent"));
	else if(str == "cot()")
		pcmd->setToolTip(tr("Cotangent"));
	else if(str == "asin()")
		pcmd->setToolTip(tr("Arcsine"));
	else if(str == "acos()")
		pcmd->setToolTip(tr("Arccosine"));
	else if(str == "acos()")
		pcmd->setToolTip(tr("Arccosine"));
	else if(str == "atan()")
		pcmd->setToolTip(tr("Arctangent"));
	else if(str == "acot()")
		pcmd->setToolTip(tr("Arccotangent"));
	else if(str == "abs()")
		pcmd->setToolTip(tr("Module"));
	else if(str == "1/()")
		pcmd->setToolTip(tr("Reverse number"));
	else if(str == "fac()")
		pcmd->setToolTip(tr("Factorial"));
	
    return pcmd;
}
void GUIPar::removeFocus()
{
	setFocusProxy(edit);
	setFocus()  ;
}
void GUIPar::Qtext()
{
	str = edit->text();

	par->SetFunction(str.toStdString().c_str());			
			
	par->start();
			
	if(par->metod_error().isEmpty() && !par->metod_operation().isEmpty())
		{
			if(par->options.formulaInLog == true)
				text->append(QString(str + "\n"));
			
			if(par->options.operationInLog == true) 
				text->append(par->metod_operation());
				
			if(par->options.resultInLog == true)
				text->append(QString("=") + QString::number(par->calculation(), par->options.type_number, par->options.precision));
								
			edit->clear();
			
			if(par->options.operationInLog == true || par->options.resultInLog == true || par->options.formulaInLog == true) text->append("------");
			enterHistory->addItem(str);	
			current = enterHistory->count();
			enterHistory->setCurrentRow(enterHistory->count() - 1);	
			if(par->variables.size()!=0)
			{
				textVar->clear();
				for(int i=0;i<par->variables.size();i++)
				{
					if(par->variables[i].x != "ans")
					textVar->append(QString(par->variables[i].x.c_str())+"="+QString::number(par->variables[i].num));
				}
			}
			
		}
	if(!par->metod_error().isEmpty())
		{	
			QMessageBox  *errorMessageDialog = new QMessageBox(this);
			errorMessageDialog->standardIcon(QMessageBox::Information);
			errorMessageDialog->setWindowTitle(tr("Parser"));
			errorMessageDialog->setText(tr("Error in parsing"));
			errorMessageDialog->setIcon(QMessageBox::Critical);
	 
			errorMessageDialog->setDetailedText(par->metod_error());
			errorMessageDialog->setStandardButtons(QMessageBox::Ok);
			errorMessageDialog->show();
			current = 0;
		}
	if(par->metod_error().isEmpty())	
		{
			resultEdit->setText(QString::number(par->calculation(),par->options.type_number, par->options.precision));
		
		}
		if(!str.isEmpty())
				emit modified(true);
	
	item = true;	
}
void GUIPar::Qcurrent_text()
{
	item = false;
	current = enterHistory->currentRow();
}
void GUIPar::getCurrentButtonForFunc()
{
	int i = 0;
	for(i = 0;i<sizeof(func)/4;i++)
		if(((QPushButton*)sender())->text() == QString(func[i])+"()") break;
			edit->insert(QString(func[i])+"()");
	
	edit->cursorBackward (false, 1); 
}
void GUIPar::getCurrentIndexList(QListWidgetItem * item)
{	
	edit->insert(item->text());
}
void GUIPar::clearQTextEdit()
{
	text->clear();
	emit modified(true);
}
void GUIPar::clearQLineEdit()
{ 
	item = true;
	edit->clear();
}
void GUIPar::clearQListWidget()
{
	item = false;
	enterHistory->clear();
}
GUIPar::~GUIPar()
{
	delete par;
}
void GUIPar::keyPressEvent(QKeyEvent *e)
{
	QKeyEvent *keyEvent = static_cast<QKeyEvent*> (e); 
	int key = keyEvent->key();
		
	if(focusWidget() == enterHistory)
	{
		if (Qt::Key_Up != key && Qt::Key_Down != key&& 16777220 == key)
		{
			edit->insert(QString(enterHistory->item(enterHistory->currentRow())->text()));
		}
	}
	else if(focusWidget() == edit)
	{
		if(enterHistory->count() != 0)
		{		
			if (Qt::Key_Up == key )
			{	
				if(item == true)
					current--;
											
				if(current < 0) current = enterHistory->count() - 1;
				enterHistory->setCurrentRow(current);
				edit->setText(QString(enterHistory->item(current)->text()));
			
				item = true;
			}
			if (Qt::Key_Down == key)
			{  
				if(item == true)
					current++;
											
				if(current>enterHistory->count() -1) current = 0;
				enterHistory->setCurrentRow(current);
				edit->setText(QString(enterHistory->item(current)->text()));
				
				item = true;
			}
		 }
	}
	if(Qt::Key_F == key || key == 1040) removeFocus();//1040    
}
bool GUIPar::saveLog(QString fname)
{
	QFile filed(fname);
    if (filed.open(QIODevice::WriteOnly)) 
	{
		QTextStream(&filed) << text->toPlainText();
        filed.close();
	}
	else return false;
	
	return true;
}
void GUIPar::Check_formulaInLog()
{
	if(formulaInLog->isChecked() == true)
		par->options.formulaInLog = true;
	else par->options.formulaInLog = false;
}
void GUIPar::Check_resultInLog()
{
	if(resultInLog->isChecked() == true)
	{
		par->options.resultInLog = true;
	}
	else	par->options.resultInLog = false;
}
void GUIPar::Check_operationInLog()
{	
	if(operationInLog->isChecked() == true)
		par->options.operationInLog = true;
	else par->options.operationInLog = false;
}
void GUIPar::Check_on_rad()
{
	if(on_rad->isChecked() == true)
		par->options.on_rad = true;
	else par->options.on_rad = false;
}
void GUIPar::setChecked_for_checkBoxs()
{
	operationInLog->setChecked(par->options.operationInLog);
	on_rad->setChecked(par->options.on_rad);
	formulaInLog->setChecked(par->options.formulaInLog);
	resultInLog->setChecked(par->options.resultInLog);
}

void GUIPar::on_textVar_textChanged()
{

}