/******************************************************************************
**    Parser
*******************************************************************************/
#pragma once
#ifndef GUIPAR_H
#define GUIPAR_H

#include "ui_guipar.h"
#include <QWidget>
#include <QMessageBox.h>
#include <QFile.h>
#include <QKeyEvent>
#include <QTextStream>
#include "..\parser.h"

using namespace Ui;

class GUIPar : public QWidget, public GUIParClass
{
	Q_OBJECT
signals:
    void modified(bool);
public:
	GUIPar(QWidget *parent = 0);
	void setChecked_for_checkBoxs();
	~GUIPar();
	parser *par;
private:
	QPushButton *createButton(const QString &str);
	QGridLayout* funcLayout;
	QString str;
	int current;
	bool item;
protected:
	void keyPressEvent(QKeyEvent*);
public slots:
	void Qcurrent_text();
	void Qtext();
	void getCurrentButtonForFunc();
	void getCurrentIndexList(QListWidgetItem * item);
	void clearQTextEdit();
	void clearQLineEdit();
	void clearQListWidget();
	void removeFocus();
	bool saveLog(QString fname);
	void Check_formulaInLog();
	void Check_resultInLog();
	void Check_operationInLog();
	void Check_on_rad();

private slots:
	void on_textVar_textChanged();
};
#endif // GUIPAR_H
