#include "../settings_dialog.h"

Settings_dialog::Settings_dialog(const Csettings &set_,QWidget *parent)
	: QDialog(parent)
{
	set = set_;
	setupUi(this);

	setWidget_status();

	connect(radioButton_Degree, SIGNAL(clicked()), this, SLOT(set_corner()));
	connect(radioButton_Radian, SIGNAL(clicked()), this, SLOT(set_corner()));

	connect(check_formulaInLog, SIGNAL(clicked()), this, SLOT(set_formulaInLog()));
	connect(check_resultInLog, SIGNAL(clicked()), this, SLOT(set_resultInLog()));
	connect(check_operationInLog, SIGNAL(clicked()), this, SLOT(set_operationInLog()));
	connect(slider_precision, SIGNAL(valueChanged(int)), this, SLOT(set_precision(int)));

	connect(comboBox_type_number, SIGNAL(currentIndexChanged(int)), this, SLOT(set_type_number(int)));
	connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
	connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));
}
void Settings_dialog::set_resultInLog()
{
	set.resultInLog=check_resultInLog->isChecked();
}
void Settings_dialog::set_operationInLog()
{
	set.operationInLog=check_operationInLog->isChecked();
}
void Settings_dialog::set_formulaInLog()
{
	set.formulaInLog=check_formulaInLog->isChecked();
}
void Settings_dialog::set_precision(int prec)
{
	set.precision = prec;
}
void Settings_dialog::set_type_number(int w)
{ 
	switch(w)
	{
		case 0: set.type_number = 'g';break;
		case 1: set.type_number = 'f';break;
		case 2:	set.type_number = 'e';break;
	}
}
void Settings_dialog::set_corner()
{
	if((((QRadioButton*)sender())->objectName()) == radioButton_Radian->objectName())
		set.on_rad = true;
	else set.on_rad = false;
}
void Settings_dialog::setWidget_status()
{
	radioButton_Degree->setChecked(!set.on_rad);
	radioButton_Radian->setChecked(set.on_rad);
	check_formulaInLog->setChecked(set.formulaInLog);
	check_resultInLog->setChecked(set.resultInLog);
	check_operationInLog ->setChecked(set.operationInLog);

	switch(set.type_number)
	{
		case 'g'	:comboBox_type_number->setCurrentIndex(0); break;
		case 'f'	:comboBox_type_number->setCurrentIndex(1); break;
		case 'e'	:comboBox_type_number->setCurrentIndex(2); break;
	}
	slider_precision->setValue(set.precision);
}